import Test.QuickCheck

squares :: [Int] -> [Int]
squares xs  =  [ x*x | x <- xs ]

odds :: [Int] -> [Int]
odds xs  =  [ x | x <- xs, odd x ]

sumSqOdd :: [Int] -> Int
sumSqOdd xs  =  sum [ x*x | x <- xs, odd x ]

prop_sumSqOdd :: [Int] -> Bool
prop_sumSqOdd xs  =  sum (squares (odds xs)) == sumSqOdd xs

sumSqOddRec :: [Int] -> Int
sumSqOddRec []                  =  0
sumSqOddRec (x:xs) | odd x      =  x*x + sumSqOddRec xs
                   | otherwise  =  sumSqOddRec xs
